<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
?>

<h2>
	<?php _e( 'General Options', 'woocommerce' ); ?>
</h2>

<h4>
	Generating Labels
</h4>
<p>Choose when new shipping labels can be generated using Shipmate in WooCommerce:</p>
<?php $shipmate_process_block = get_option("_shipmate_process_block"); ?>
<input type="radio" name="shipmate_process_block" value="true" <?php checked( 'true' == $shipmate_process_block || empty($shipmate_process_block)); ?> />
<label for="true">Only when the order status is Processing</label><br>
<br>
<input type="radio" name="shipmate_process_block" value="false" <?php checked( 'false' == $shipmate_process_block); ?> />
<label for="false">For any order status</label><br>

<h4>
	Units of Measure
</h4>
<p>Choose which units of measure you wish to use with Shipmate inside WooCommerce:
<table class="widefat">
	<thead>
		<tr>
			<th width="50%">Measurement</th>
			<th width="50%">Units</th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td>Dimensions</td>
			<td>
				<?php $dimensions_unit = get_option("_shipmate_dimensions_unit"); ?>
				<select name="shipmate_dimensions_unit">
					<option value="mm" <?php echo $dimensions_unit == "mm" ? ' selected="selected"': ''; ?> >mm</option>
					<option value="cm" <?php echo $dimensions_unit == "cm" ? ' selected="selected"': ''; ?> >cm</option>
					<option value="m" <?php echo $dimensions_unit == "m" ? ' selected="selected"': ''; ?> >m</option>
				</select>
			</td>
		</tr>
		<tr>
			<td>Weights</td>
			<td>
				<?php $weights_unit = get_option("_shipmate_weights_unit"); ?>
				<select name="shipmate_weights_unit">
					<option value="g" <?php echo $weights_unit == "g" ? ' selected="selected"': ''; ?> >g</option>
					<option value="kg" <?php echo $weights_unit == "kg" ? ' selected="selected"': ''; ?> >kg</option>
				</select>
			</td>
		</tr>

	</tfoot>
</table>


<h4>
	Updating Order Statuses
</h4>
<p>Choose how Shipmate updates the status of your orders when generating labels and under other conditions:
<table class="widefat">
	<thead>
		<tr>
			<th width="50%">Event</th>
			<th width="50%">Status</th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td>Successful Shipmate Order Creation</td>
			<td>
				<?php $success_status = get_option("_shipmate_status_success"); ?>
				<select name="shipmate_success_status">
					<option value="Don't Change" <?php echo $success_status == "Don't Change" ? ' selected="selected"': ''; ?> >Don't change status</option>
					<?php foreach(wc_get_order_statuses() as $key =>  $status) { ?>
						<option value="<?php echo $key ?>" <?php echo $success_status == $key ? ' selected="selected"': ''; ?> ><?php echo $status; ?></option>
					<?php } ?>
				</select>
			</td>
		</tr>
		<tr>
			<td>Failed Shipmate Order Creation</td>
			<td>
				<?php $failed_status = get_option("_shipmate_status_failed"); ?>
				<select name="shipmate_failed_status">
					<option value="Don't Change" <?php echo $failed_status == "Don't Change" ? ' selected="selected"': ''; ?> >Don't change status</option>
					<?php foreach(wc_get_order_statuses() as $key => $status) { ?>
						<option value="<?php echo $key ?>" <?php echo $failed_status == $key ? ' selected="selected"': ''; ?> ><?php echo $status; ?></option>
					<?php } ?>
				</select>
			</td>
		</tr>

		<tr>
			<td>Shipmate Order Cancellation</td>
			<td>
				<?php $cancel_status = get_option("_shipmate_status_cancel"); ?>
				<select name="shipmate_cancel_status">
					<option value="Don't Change" <?php echo $cancel_status == "Don't Change" ? ' selected="selected"': ''; ?> >Don't change status</option>
					<?php foreach(wc_get_order_statuses() as $key => $status) { ?>
						<option value="<?php echo $key ?>" <?php echo $cancel_status == $key ? ' selected="selected"': ''; ?> ><?php echo $status; ?></option>
					<?php } ?>
				</select>
			</td>
		</tr>
	</tfoot>
</table>
