<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/flatpickr/dist/flatpickr.min.css">
<?php if(!empty(get_option('shipmate_sender_token', null))) { ?>
	<?php if(!empty($parcels)) { ?>
		<p>Your labels have been printed with Shipmate, details of your parcels are below. </p>
		<p><a href="#" class="button-primary" id="btn-print-label">Reprint Labels with Shipmate</a></p>
		<hr>
		<p><b>Carrier: </b><?php echo $shipmate_carrier; ?><br><b>Service: </b><?php echo $shipmate_service; ?></p>
		<hr>
		<?php foreach($parcels as $parcel) { ?>
			<p>
				<b>Reference: </b> <?php echo $parcel['sender_reference']; ?><br>
				<b>Tracking: </b> <?php echo $parcel['tracking_reference']; ?><br>
				<b>Weight: </b> <?php echo $parcel['weight']; ?> g<br>
				<b>Length: </b> <?php echo $parcel['length']; ?> cm<br>
				<b>Width: </b> <?php echo $parcel['width']; ?> cm<br>
				<b>Depth: </b> <?php echo $parcel['depth']; ?> cm<br>
				<?php if(!empty($recent_event)) { ?>
					<br><b>Delivery Status: </b><br><?php echo $parcel['recent_event']->name; ?><br><?php echo $parcel['recent_event']->description; ?><br><?php echo $parcel['recent_event']->date; ?><br>
				<?php } ?>
			</p>
			<hr>
		<?php } ?>
	<?php } else { ?>
		<!-- If the parcel is is any other state apart form processing or complete then just display a message -->
		<?php if($status == "wc-processing" || get_option("_shipmate_process_block") == 'false') { ?>
			<p>Your labels have not been printed yet for this order.</p>
			<p><a href="#" class="button-primary" id="btn-print-label">Print Labels with Shipmate</a></p>
		<?php } else { ?>
			<p>Please update your order status to <b>Processing</b> to print a label with Shipmate</p>
		<?php } ?>
	<?php } ?>
<?php } ?>

<div id="wc-modal-shipmate" style="display:none;">
	<div class="wc-backbone-modal wc-modal-shipmate">
		<div class="wc-backbone-modal-content">
			<section class="wc-backbone-modal-main" role="main">
				<!-- <form method="post" action="post.php" name="post">
					<?php wp_nonce_field(); ?> -->
					<header class="wc-backbone-modal-header">
						<h1><?php _e( 'Print Shipping Labels', 'woocommerce' ); ?></h1>
						<button class="modal-close modal-close-link dashicons dashicons-no-alt" id="btn-wc-modal-shipmate-close">
							<span class="screen-reader-text">Close modal panel</span>
						</button>
					</header>
					<article>
						<p>Please <strong>split this order into parcels</strong>, including weight and dimensions to generate your labels.</p>
						<div id="wc-modal-shipmate-package-alert" style="display: none; color: red; margin-bottom: 20px;">
							Please ensure that all fields are filled out before creating labels.
						</div>
						<div class="tableContainer">
							<table class="table">
								<thead>
									<tr>
										<th>#</th>
										<th width="120px">Weight</th>
										<th width="120px">Length</th>
										<th width="120px">Width</th>
										<th width="120px">Depth</th>
										<?php if(!empty($packaging_options->types)) { ?>
											<th width="140px">Packaging Options</th>
										<?php } ?>
										<th width="40px"></th>
									</tr>
								</thead>
								<tbody id="wc-modal-shipmate-parcels-container">
									<?php if(!empty($parcels)) { ?>
										<?php foreach($parcels as $key => $parcel) { ?>
											<tr>
												<td class="shipmate-package-parcel-number"><?php echo $key + 1; ?></td>
												<td><div class="inputGroup"><input type="text" disabled name="parcel_dimensions[parcel_weights][]" class="wc-modal-shipmate-package-input inputGroup-input" value="<?php echo !empty($parcel_weights[$key]) ? $parcel_weights[$key] : ''; ?>"><span class="inputGroup-text"><?php echo get_option("_shipmate_weights_unit"); ?></span></div></td>
												<td><div class="inputGroup"><input type="text" disabled name="parcel_dimensions[parcel_lengths][]" class="wc-modal-shipmate-package-input inputGroup-input" value="<?php echo !empty($parcel_lengths[$key]) ? $parcel_lengths[$key] : ''; ?>"><span class="inputGroup-text"><?php echo get_option("_shipmate_dimensions_unit"); ?></span></div></td>
												<td><div class="inputGroup"><input type="text" disabled name="parcel_dimensions[parcel_widths][]" class="wc-modal-shipmate-package-input inputGroup-input" value="<?php echo !empty($parcel_widths[$key]) ? $parcel_widths[$key] : ''; ?>"><span class="inputGroup-text"><?php echo get_option("_shipmate_dimensions_unit"); ?></span></div></td>
												<td><div class="inputGroup"><input type="text" disabled name="parcel_dimensions[parcel_depths][]" class="wc-modal-shipmate-package-input inputGroup-input" value="<?php echo !empty($parcel_depths[$key]) ? $parcel_depths[$key] : ''; ?>"><span class="inputGroup-text"><?php echo get_option("_shipmate_dimensions_unit"); ?></span></div></td>
												<td></td>
											</tr>
										<?php } ?>
									<?php } ?>
								</tbody>
							</table>
						</div>
						<?php if(empty($parcels)) { ?>
							<a href="#" id="wc-modal-shipmate-add-parcel"><svg width="16" height="16" xmlns="http://www.w3.org/2000/svg"><g fill="#0073B1" fill-rule="nonzero"><path d="M9 4H7v3H4v2h3v3h2V9h3V7H9z"/><path d="M8 0C3.6 0 0 3.6 0 8s3.6 8 8 8 8-3.6 8-8-3.6-8-8-8zm0 14c-3.3 0-6-2.7-6-6s2.7-6 6-6 6 2.7 6 6-2.7 6-6 6z"/></g></svg>Add Parcel</a>
						<?php } ?>
						<hr class="table-divider">
						<div class="row">
							<?php if(!empty($shipmate_services)) { ?>
								<div id="wc-shipmate-services">
									<label class="label">Delivery Service</label>
									<select name="delivery_service_key">
										<option value="">Use Routing Rules</option>
										<?php foreach($shipmate_services as $shipmate_service) { ?>
											<?php if(!empty($shipmate_service->key)) { ?>
												<option value="<?php echo $shipmate_service->key; ?>"><?php echo $shipmate_service->name; ?></option>
											<?php } ?>
										<?php } ?>
									</select>
								</div>
							<?php } ?>
							
							<?php if(empty($parcels)) { ?>
								<div id="wc-shipmate-dispatch-date">
									<label class="label">Despatch Date</label>
									<input type="text" id="datepicker" class="white-bg" name="dispatch_date">
								</div>
							<?php } ?>
						</div>

					</article>
					<footer>
						<div class="inner">
							<svg width="115" height="12" xmlns="http://www.w3.org/2000/svg"><g fill="#999" fill-rule="nonzero"><path d="M1.76 9V6.22h1.68c.8 0 1.42-.19 1.85-.56a2 2 0 00.65-1.6c0-.65-.22-1.18-.66-1.57-.45-.4-1.05-.6-1.83-.6H.83V9h.93zm1.69-3.55H1.76V2.66H3.5c.47.01.83.14 1.1.4.27.25.4.59.4 1.01 0 .45-.13.79-.4 1.03-.27.23-.65.35-1.15.35zM9.1 9.1a2.24 2.24 0 002.1-1.3c.2-.4.3-.87.3-1.38v-.07c0-.82-.22-1.49-.67-1.98a2.23 2.23 0 00-1.74-.75 2.28 2.28 0 00-2.1 1.3c-.2.4-.3.87-.3 1.39v.06c0 .82.22 1.48.67 1.98.44.5 1.02.75 1.74.75zm0-.74A1.3 1.3 0 018 7.83c-.27-.36-.4-.83-.4-1.41 0-.66.13-1.17.4-1.53a1.3 1.3 0 011.09-.53c.45 0 .82.18 1.1.54.27.36.4.83.4 1.41 0 .65-.13 1.15-.4 1.51a1.3 1.3 0 01-1.1.54zm5.32.64l1.25-4 1.29 4h.73l1.54-5.28h-.9L17.3 7.75l-1.26-4.03h-.72L14.1 7.67l-1.04-3.95h-.9L13.69 9h.73zm7.92.1c.88 0 1.55-.34 2-1.02l-.56-.43c-.17.21-.36.38-.58.52-.22.13-.5.19-.81.19-.45 0-.82-.16-1.11-.48-.3-.32-.45-.74-.46-1.26h3.58v-.38c0-.84-.2-1.49-.57-1.94a1.98 1.98 0 00-1.6-.68c-.42 0-.81.12-1.17.35-.36.23-.64.55-.84.97-.2.4-.3.87-.3 1.4v.16c0 .8.22 1.42.67 1.9.45.46 1.03.7 1.75.7zm1.16-3.22h-2.65c.06-.48.21-.86.46-1.12.25-.27.55-.4.92-.4s.67.13.9.38c.22.25.34.6.37 1.07v.07zM26.35 9V5.25c.2-.5.61-.76 1.2-.76.16 0 .31.01.45.04v-.84a.92.92 0 00-.4-.07c-.55 0-.97.24-1.26.7l-.02-.6h-.88V9h.9zm4.58.1c.88 0 1.55-.34 1.99-1.02l-.55-.43c-.17.21-.36.38-.58.52-.22.13-.5.19-.81.19-.45 0-.82-.16-1.11-.48-.3-.32-.45-.74-.46-1.26h3.58v-.38c0-.84-.2-1.49-.57-1.94a1.98 1.98 0 00-1.6-.68c-.42 0-.81.12-1.17.35-.36.23-.64.55-.84.97-.2.4-.3.87-.3 1.4v.16c0 .8.22 1.42.67 1.9.45.46 1.03.7 1.75.7zm1.15-3.22h-2.64c.06-.48.21-.86.46-1.12.24-.27.55-.4.92-.4s.67.13.9.38c.22.25.34.6.36 1.07v.07zm3.8 3.22c.65 0 1.16-.22 1.52-.67l.04.57h.83V1.5h-.9v2.75a1.83 1.83 0 00-1.47-.63c-.62 0-1.13.25-1.51.74a3.1 3.1 0 00-.58 1.95v.07c0 .81.2 1.46.58 1.97.39.5.89.75 1.5.75zm.23-.77a1.2 1.2 0 01-1.02-.5c-.25-.35-.37-.81-.37-1.41 0-.67.12-1.18.37-1.52.25-.34.59-.51 1.03-.51.56 0 .98.24 1.25.74v2.43c-.27.51-.68.77-1.26.77zm8.46.77c.63 0 1.12-.25 1.5-.74.37-.49.55-1.14.55-1.94v-.08c0-.84-.18-1.5-.55-2a1.79 1.79 0 00-1.5-.72c-.65 0-1.15.23-1.52.68V1.5h-.9V9h.83l.04-.61c.37.47.88.7 1.55.7zm-.22-.77c-.59 0-1.02-.28-1.3-.83V5.22c.26-.56.69-.83 1.29-.83.44 0 .78.16 1.02.5.24.33.36.8.36 1.42a2.6 2.6 0 01-.36 1.52c-.24.33-.58.5-1.01.5zm3.59 2.8c.72 0 1.24-.44 1.57-1.31l2.12-6.1h-.97l-1.23 3.96-1.31-3.96h-1l1.9 5.22-.2.54c-.12.33-.26.55-.43.68-.17.12-.4.18-.71.18l-.25-.02v.74l.34.06.17.01zM55.19 7.48a.98.98 0 01-.19-.53c0-.41.27-.73.75-.73a.7.7 0 01.62.3c.48.73 1.05 1.1 2.13 1.1 1.08 0 1.7-.49 1.7-1.18 0-2.08-4.9-.64-4.9-3.87C55.33.9 56.8.11 58.38.11c1.35 0 2.26.41 2.8 1.33.08.15.13.31.14.48 0 .49-.31.74-.72.74a.75.75 0 01-.62-.39c-.37-.58-.87-.83-1.6-.83-.95 0-1.6.36-1.6 1.11 0 1.72 4.87.66 4.87 3.8 0 1.75-1.47 2.6-3.14 2.6-1.64 0-2.64-.48-3.31-1.47zM63.05 8.18V.88c0-.37.29-.64.7-.64s.69.27.69.65v2.55c.3-.47.95-.88 1.78-.88 1.36 0 2.2.76 2.2 2.2v3.42c0 .36-.28.65-.68.65a.65.65 0 01-.69-.65V4.94c0-.83-.44-1.13-1.06-1.13-.82 0-1.55.77-1.55 1.96v2.41c0 .36-.28.65-.7.65-.4 0-.68-.29-.68-.65h-.01zM69.77 8.21c0-.38.22-.61.65-.61h1.72V3.92h-1.36c-.41 0-.65-.24-.65-.62s.24-.61.65-.61h1.98c.52 0 .74.21.74.74V7.6h1.72c.41 0 .65.23.65.61s-.24.62-.65.62h-4.8c-.41 0-.65-.24-.65-.62zm1.98-7.2a.9.9 0 111.82 0 .9.9 0 01-1.82 0zM77.13 10.63V3.34c0-.37.27-.65.69-.65.3-.02.57.18.66.47.47-.4 1.07-.6 1.68-.6 1.81 0 2.86 1.37 2.86 3.2 0 1.81-1.06 3.2-2.87 3.2-.67 0-1.23-.2-1.65-.55v2.23c0 .37-.3.65-.7.65-.4 0-.68-.28-.68-.65zm4.48-4.87c0-1.26-.57-1.96-1.54-1.96-.97 0-1.56.7-1.56 1.95 0 1.26.6 1.97 1.57 1.97.98 0 1.54-.7 1.54-1.96zM84.25 8.18V3.34c0-.37.28-.65.69-.65.36 0 .62.16.68.51.25-.42.75-.64 1.25-.64.62 0 .98.2 1.22.68.39-.5.82-.68 1.39-.68.94 0 1.44.49 1.44 1.6v4.01c0 .37-.28.66-.68.66s-.7-.29-.7-.66V4.4c0-.42-.18-.61-.54-.61-.52 0-.73.56-.73 1.36v3.03c0 .36-.29.65-.69.65-.4 0-.69-.29-.69-.65V4.4c0-.42-.18-.61-.53-.61-.54 0-.74.56-.74 1.36v3.03c0 .36-.28.65-.7.65a.65.65 0 01-.67-.65zM92.14 5.76c0-1.85 1.13-3.19 2.94-3.19.8 0 1.33.22 1.76.62.09-.3.37-.5.68-.5.42 0 .7.27.7.64v4.84c0 .37-.3.65-.7.65-.3 0-.59-.2-.68-.5-.42.4-.96.62-1.76.62-1.83.01-2.94-1.36-2.94-3.19v.01zm4.7 0c0-1.26-.66-1.96-1.68-1.96-.97 0-1.63.7-1.63 1.95 0 1.26.66 1.97 1.63 1.97 1.02 0 1.68-.7 1.68-1.96zM101.5 6.63v-2.7h-1.47c-.42 0-.65-.25-.65-.63s.23-.61.65-.61h1.47V.76c0-.37.29-.65.69-.65.4 0 .69.28.69.65V2.7h2.03c.42 0 .65.23.65.61s-.23.62-.65.62h-2.03v2.75c0 .77.36 1.05.9 1.05.41.01.83-.13 1.14-.41.11-.1.25-.16.4-.17.38 0 .6.31.6.63 0 .22-.12.42-.3.55-.53.43-1.13.63-1.91.63-1.13 0-2.21-.5-2.21-2.32zM106.89 5.76c0-1.85 1.28-3.19 3.13-3.19a2.91 2.91 0 013.02 3c0 .52-.27.75-.65.75h-4.05c.12.86.85 1.4 1.75 1.4.62.04 1.22-.2 1.65-.65a.75.75 0 01.51-.25c.41 0 .64.3.64.64a.8.8 0 01-.26.57c-.7.72-1.66.92-2.61.92-1.95 0-3.13-1.35-3.13-3.19zm4.79-.67a1.65 1.65 0 00-1.66-1.28c-.8 0-1.5.42-1.68 1.3l3.34-.02zM113.04 1.06a.96.96 0 111.92-.02.96.96 0 01-1.92.02zm1.62 0a.64.64 0 00-.6-.68h-.07c-.42 0-.65.32-.65.68 0 .36.23.67.66.67.35 0 .64-.27.65-.62v-.05h.01zm-1.03.34V.71a.1.1 0 01.1-.11h.34c.21 0 .33.11.33.29 0 .12-.07.23-.18.26l.16.19c.02.02.02.04.02.07a.1.1 0 01-.1.1h-.01a.1.1 0 01-.1-.04l-.22-.3h-.1v.22c0 .07-.06.12-.13.12a.11.11 0 01-.1-.11zm.41-.41c.09 0 .13-.01.13-.1 0-.1-.04-.1-.14-.1h-.16v.2h.17z"/></g></svg>
							<button id="wc-modal-shipmate-print-labels-button" type="submit" class="button button-primary button-large"><?php _e( 'Print with Shipmate', 'woocommerce' ); ?></button>
						</div>
					</footer>
				<!-- </form> -->
			</section>
		</div>
	</div>
	<div class="wc-backbone-modal-backdrop modal-close"></div>
</div>

<div id="template-shipmate-package" style="display:none;">
	<table>
		<tr>
			<td class="shipmate-package-parcel-number" style="text-align: center;"></td>
			<td><div class="inputGroup"><input type="text" name="parcel_dimensions[parcel_weights][]" class="wc-modal-shipmate-package-input inputGroup-input"><span class="inputGroup-text"><?php echo get_option("_shipmate_weights_unit"); ?></span></div></td>
			<td><div class="inputGroup"><input type="text" name="parcel_dimensions[parcel_lengths][]" class="wc-modal-shipmate-package-input inputGroup-input"><span class="inputGroup-text"><?php echo get_option("_shipmate_dimensions_unit"); ?></span></div></td>
			<td><div class="inputGroup"><input type="text" name="parcel_dimensions[parcel_widths][]" class="wc-modal-shipmate-package-input inputGroup-input"><span class="inputGroup-text"><?php echo get_option("_shipmate_dimensions_unit"); ?></span></div></td>
			<td><div class="inputGroup"><input type="text" name="parcel_dimensions[parcel_depths][]" class="wc-modal-shipmate-package-input inputGroup-input"><span class="inputGroup-text"><?php echo get_option("_shipmate_dimensions_unit"); ?></span></div></td>

			
			<?php if(!empty($packaging_options->types)) { ?>
			<td>
				
					<!-- <b>Select a Packaging Type:</b> -->
					<select id="packaging_type" name="packaging_type">
						<?php if($packaging_options->option->packaging_dimension_override) { ?>
							<option value="">- None - </option>
						<?php } ?>
						<?php foreach($packaging_options->types as $type) { ?>
							<option value="<?php echo $type->id; ?>" <?php selected($type->id, $packaging_options->option->default_packaging_type_id)?> data-value='<?php echo(wp_json_encode($type)) ?>'><?php echo $type->name; ?></option>
						<?php } ?>
					</select>
				
			</td>
			<?php } ?>
					
			<td style="padding-left:10px;"><span class="dashicons dashicons-no-alt removeRowIcon"></span></td>
		</tr>
	</table>
</div>
<script src="https://cdn.jsdelivr.net/npm/flatpickr"></script>
<script type="text/javascript">

	var parcel_rows = 0;

	parcel_row_count_updated();

	function add_parcel_row_count() {
		parcel_rows = parcel_rows + 1
		parcel_row_count_updated()
	}

	function remove_parcel_row_count() {
		parcel_rows = parcel_rows - 1
		parcel_row_count_updated()
	}

	function parcel_row_count_updated() {
		var table = document.getElementById('wc-modal-shipmate-parcels-container');
		
		if(parcel_rows == 1) {
			table.classList.add('single');
		} else {
			table.classList.remove('single');
		}
	}

	var minDate = new Date();
	minDate.setDate(minDate.getDate());

	flatpickr("#datepicker", {
		minDate: minDate,
		defaultDate: minDate,
		onReady (_, __, fp) {
    		fp.calendarContainer.classList.add("push-forward");
  		}
	});
	// we should trigger a modal when wc_order_action is = to one of our options if needs be and pull the dims + weight out if they exist
	var order_actions_button = document.getElementsByName('wc_order_action')[0];
	var shipmate_packaging_modal = document.getElementById('wc-modal-shipmate');
	var shipmate_packaging_modal_close_button = document.getElementById('btn-wc-modal-shipmate-close');

	var shipmate_print_button = document.getElementById('btn-print-label')

	var shipmate_packaging_parcels_container = document.getElementById('wc-modal-shipmate-parcels-container');
	var shipmate_packaging_add_parcel_button = document.getElementById('wc-modal-shipmate-add-parcel');

	var shipmate_print_labels_button = document.getElementById('wc-modal-shipmate-print-labels-button');

	var shipmate_packaging_parcel_row_template = document.getElementById('template-shipmate-package').getElementsByTagName("table")[0].getElementsByTagName("tr")[0];

	var shipmate_packaging_type_select = document.getElementById('packaging_type');




	
	if(order_actions_button.options[order_actions_button.selectedIndex].value == "wc_order_print_label") {
		order_actions_button.selectedIndex = 0;
	}

	shipmate_print_labels_button.addEventListener('click', function(event) {

		// step one - check that fields are filled out
		var inputs = shipmate_packaging_parcels_container.getElementsByClassName('wc-modal-shipmate-package-input');

		// track whether the form passes validation. It can't pass without parcels
		var validation_passes = inputs.length > 0 ? true : false;

		// check all inputs are filled in and check that they are numeric values
		for(var i = 0; i < inputs.length; i++) {
			var inputValue = inputs[i].value;

			if(inputValue == "" || isNaN(inputValue)) {
				validation_passes = false;
			}
		}

		// validation passes - let us try to build!
		if(validation_passes) {
			// shipmate_print_labels_button.disabled = true;
			shipmate_print_labels_button.innerHTML = "Printing...";
			
		} else {

			// something didnt work here.. show the alerta
			document.getElementById('wc-modal-shipmate-package-alert').style.display = "block";
			event.preventDefault();
			return false;
		}
	});





	order_actions_button.addEventListener("change", function() {
		var selected_option = order_actions_button.options[order_actions_button.selectedIndex].value;

		// print - this should show us a modal, as at this point we haven't created the label yet!
		if(selected_option == "wc_order_print_label") {
			shipmate_packaging_modal.style.display = "block";

			if(shipmate_packaging_parcels_container.childElementCount == 0) {
				add_parcel_row_single();
			}
		}
	});


	

	// manual button click
	shipmate_print_button.addEventListener("click", function() {
		shipmate_packaging_modal.style.display = "block";

		if(shipmate_packaging_parcels_container.childElementCount == 0) {

			var total = <?php echo($start_count); ?>;

			for(var i = 0; i < total; i++) {
				add_parcel_row_single();
			}


			
		}


		//wc_order_print_label
		var order_actions = document.getElementsByName('wc_order_action')[0];
		order_actions.value = "wc_order_print_label"
	});

	// add a new parcel row to the table
	if(shipmate_packaging_add_parcel_button) {
		shipmate_packaging_add_parcel_button.addEventListener('click', function(event) {
			add_parcel_row_single();
			event.preventDefault();
			return false;
		});
	}

	// close the modal if it is not wanted
	shipmate_packaging_modal_close_button.addEventListener('click', function(event) {
		shipmate_packaging_modal.style.display = "none";

		// reset the order actions box selection
		order_actions_button.selectedIndex = 0;

		// prevent the form submission default
		event.preventDefault();
		return false;
	});


	function naturaw_parcel_adder() {
		//Get the total weight of the order t
	}

	function add_parcel_row_single() {
		if(shipmate_packaging_type_select != null) {
			var packaging_type = shipmate_packaging_type_select.options[shipmate_packaging_type_select.selectedIndex];
		}
		var parcel_row_index = shipmate_packaging_parcels_container.children.length;

		var new_parcel_row = shipmate_packaging_parcel_row_template.cloneNode(true);

		// hook up the remove row button
		var new_parcel_remove_button = new_parcel_row.getElementsByClassName('removeRowIcon')[0];
		new_parcel_remove_button.addEventListener('click', function(event) {
			var parent_cell = event.target.parentNode;
			var parent_row = parent_cell.parentNode;
			remove_parcel_row(parent_row);
		});


		var new_parcel_packaging_type = new_parcel_row.getElementsByTagName('select')[0];

		if(new_parcel_packaging_type != null) {
			new_parcel_packaging_type.addEventListener("change", function(event) {

				//var packaging_type = event.options[shipmate_packaging_type_select.selectedIndex];
				var selectElement = event.target.options[event.target.selectedIndex];
				var parent_cell = event.target.parentNode;
				var parent_row = parent_cell.parentNode;
				if(selectElement.hasAttribute("data-value")) {
					var packaging_type_data = JSON.parse(selectElement.dataset.value);
					//Weight
					<?php if(!$created_with_shipmate) { ?>
						<?php if(!empty($packaging_options->types)) { ?>
							<?php if($packaging_options->option->weight_calculation_option) { ?>
								parent_row.children[1].firstChild.firstChild.value = weightChange(packaging_type_data.default_weight) + weightChange(packaging_type_data.packaging_weight) ;
							<?php } else { ?>	
								parent_row.children[1].firstChild.firstChild.value = weightChange(packaging_type_data.default_weight);
							<?php } ?>
						<?php } ?>
					<?php } ?>


					//Length
					parent_row.children[2].firstChild.firstChild.value = dimensionChange(packaging_type_data.external_height);
					//Width
					parent_row.children[3].firstChild.firstChild.value = dimensionChange(packaging_type_data.external_width);
					//Depth
					parent_row.children[4].firstChild.firstChild.value = dimensionChange(packaging_type_data.external_depth);
				}		
			});
		}
		//console.log(new_parcel_packaging_type);

		//If there is a selected index that is not that has a data value then we use it to fill out the fields
		if(packaging_type != null) {
			if(packaging_type.hasAttribute("data-value")) {
				var packaging_type_data = JSON.parse(packaging_type.dataset.value);
				//Weight
				<?php if(!$created_with_shipmate) { ?>
					<?php if(!empty($packaging_options->types)) { ?>
						<?php if($packaging_options->option->weight_calculation_option) { ?>
							new_parcel_row.cells[1].firstChild.firstChild.value = weightChange(packaging_type_data.default_weight) + weightChange(packaging_type_data.packaging_weight) ;
						<?php } else { ?>	
							new_parcel_row.cells[1].firstChild.firstChild.value = weightChange(packaging_type_data.default_weight);
						<?php } ?>
					<?php } ?>
				<?php } ?>



				//Length
				new_parcel_row.cells[2].firstChild.firstChild.value = dimensionChange(packaging_type_data.external_height);
				//Width
				new_parcel_row.cells[3].firstChild.firstChild.value = dimensionChange(packaging_type_data.external_width);
				//Depth
				new_parcel_row.cells[4].firstChild.firstChild.value = dimensionChange(packaging_type_data.external_depth);
			}
		}

		<?php if(!$created_with_shipmate) { ?>
			<?php if(!empty($packaging_options->types)) { ?>
				<?php if($packaging_options->option->packaging_dimension_override) { ?>
					new_parcel_row.cells[1].firstChild.firstChild.disabled = false;
					new_parcel_row.cells[2].firstChild.disabled = false;
					new_parcel_row.cells[3].firstChild.disabled = false;
					new_parcel_row.cells[4].firstChild.disabled = false;
				<?php } else { ?>
					new_parcel_row.cells[1].firstChild.firstChild.disabled = true;
					new_parcel_row.cells[2].firstChild.firstChild.disabled = true;
					new_parcel_row.cells[3].firstChild.firstChild.disabled = true;
					new_parcel_row.cells[4].firstChild.firstChild.disabled = true;
				<?php } ?>
			<?php } ?>
		<?php } ?>
		

		//console.log(new_parcel_row);


		// add the row
		shipmate_packaging_parcels_container.appendChild(new_parcel_row);

		renumber_parcels();

		add_parcel_row_count();
	}

	function renumber_parcels() {
		// console.log(shipmate_packaging_parcels_container.childNodes);
		var parcel_number_spans = document.getElementById('wc-modal-shipmate').getElementsByClassName('shipmate-package-parcel-number');
		
		for(var i = 0; i < parcel_number_spans.length; i++) {
			parcel_number_spans[i].innerHTML = i + 1;
		}
	}

	function remove_parcel_row(parcel_row) {
		// remove a parcel row and and renumber rows
		shipmate_packaging_parcels_container.removeChild(parcel_row);
		renumber_parcels();
		
		remove_parcel_row_count()
	}

	function dimensionChange(value) {
		<?php if(get_option("_shipmate_dimensions_unit") == "cm") { ?>
			return value;
		<?php } else if(get_option("_shipmate_dimensions_unit") == "mm") { ?>
			return value * 10;
		<?php } else if(get_option("_shipmate_dimensions_unit") == "m") { ?>
			return value / 100;
		<?php } ?>
	}

	function weightChange(value) {
		<?php if(get_option("_shipmate_weights_unit") == "g") { ?>
			return value;
		<?php } else if(get_option("_shipmate_weights_unit") == "kg") { ?>
			return value / 1000;
		<?php } ?>
	}


</script>
